/**
 * @name string-extract-class-names
 * @fileoverview Extracts CSS class/id names from a string
 * @version 8.0.16
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-extract-class-names/}
 */

"use strict";var stringExtractClassNames=(()=>{var C=Object.create;var h=Object.defineProperty;var E=Object.getOwnPropertyDescriptor;var N=Object.getOwnPropertyNames;var j=Object.getPrototypeOf,R=Object.prototype.hasOwnProperty;var O=(e,r)=>()=>(r||e((r={exports:{}}).exports,r),r.exports),B=(e,r)=>{for(var o in r)h(e,o,{get:r[o],enumerable:!0})},w=(e,r,o,a)=>{if(r&&typeof r=="object"||typeof r=="function")for(let n of N(r))!R.call(e,n)&&n!==o&&h(e,n,{get:()=>r[n],enumerable:!(a=E(r,n))||a.enumerable});return e};var v=(e,r,o)=>(o=e!=null?C(j(e)):{},w(r||!e||!e.__esModule?h(o,"default",{value:e,enumerable:!0}):o,e)),M=e=>w(h({},"__esModule",{value:!0}),e);var b=O((H,S)=>{"use strict";S.exports=L;function d(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function L(e){if(e=e||{},e.circles)return T(e);return e.proto?a:o;function r(n,l){for(var i=Object.keys(n),t=new Array(i.length),u=0;u<i.length;u++){var s=i[u],f=n[s];typeof f!="object"||f===null?t[s]=f:f instanceof Date?t[s]=new Date(f):ArrayBuffer.isView(f)?t[s]=d(f):t[s]=l(f)}return t}function o(n){if(typeof n!="object"||n===null)return n;if(n instanceof Date)return new Date(n);if(Array.isArray(n))return r(n,o);if(n instanceof Map)return new Map(r(Array.from(n),o));if(n instanceof Set)return new Set(r(Array.from(n),o));var l={};for(var i in n)if(Object.hasOwnProperty.call(n,i)!==!1){var t=n[i];typeof t!="object"||t===null?l[i]=t:t instanceof Date?l[i]=new Date(t):t instanceof Map?l[i]=new Map(r(Array.from(t),o)):t instanceof Set?l[i]=new Set(r(Array.from(t),o)):ArrayBuffer.isView(t)?l[i]=d(t):l[i]=o(t)}return l}function a(n){if(typeof n!="object"||n===null)return n;if(n instanceof Date)return new Date(n);if(Array.isArray(n))return r(n,a);if(n instanceof Map)return new Map(r(Array.from(n),a));if(n instanceof Set)return new Set(r(Array.from(n),a));var l={};for(var i in n){var t=n[i];typeof t!="object"||t===null?l[i]=t:t instanceof Date?l[i]=new Date(t):t instanceof Map?l[i]=new Map(r(Array.from(t),a)):t instanceof Set?l[i]=new Set(r(Array.from(t),a)):ArrayBuffer.isView(t)?l[i]=d(t):l[i]=a(t)}return l}}function T(e){var r=[],o=[];return e.proto?l:n;function a(i,t){for(var u=Object.keys(i),s=new Array(u.length),f=0;f<u.length;f++){var m=u[f],p=i[m];if(typeof p!="object"||p===null)s[m]=p;else if(p instanceof Date)s[m]=new Date(p);else if(ArrayBuffer.isView(p))s[m]=d(p);else{var A=r.indexOf(p);A!==-1?s[m]=o[A]:s[m]=t(p)}}return s}function n(i){if(typeof i!="object"||i===null)return i;if(i instanceof Date)return new Date(i);if(Array.isArray(i))return a(i,n);if(i instanceof Map)return new Map(a(Array.from(i),n));if(i instanceof Set)return new Set(a(Array.from(i),n));var t={};r.push(i),o.push(t);for(var u in i)if(Object.hasOwnProperty.call(i,u)!==!1){var s=i[u];if(typeof s!="object"||s===null)t[u]=s;else if(s instanceof Date)t[u]=new Date(s);else if(s instanceof Map)t[u]=new Map(a(Array.from(s),n));else if(s instanceof Set)t[u]=new Set(a(Array.from(s),n));else if(ArrayBuffer.isView(s))t[u]=d(s);else{var f=r.indexOf(s);f!==-1?t[u]=o[f]:t[u]=n(s)}}return r.pop(),o.pop(),t}function l(i){if(typeof i!="object"||i===null)return i;if(i instanceof Date)return new Date(i);if(Array.isArray(i))return a(i,l);if(i instanceof Map)return new Map(a(Array.from(i),l));if(i instanceof Set)return new Set(a(Array.from(i),l));var t={};r.push(i),o.push(t);for(var u in i){var s=i[u];if(typeof s!="object"||s===null)t[u]=s;else if(s instanceof Date)t[u]=new Date(s);else if(s instanceof Map)t[u]=new Map(a(Array.from(s),l));else if(s instanceof Set)t[u]=new Set(a(Array.from(s),l));else if(ArrayBuffer.isView(s))t[u]=d(s);else{var f=r.indexOf(s);f!==-1?t[u]=o[f]:t[u]=l(s)}}return r.pop(),o.pop(),t}}});var _={};B(_,{extract:()=>F,version:()=>W});var $=v(b(),1);var J=(0,$.default)();var D=v(b(),1);var X=(0,D.default)();var g="\xA0";function V({str:e,idx:r=0,stopAtNewlines:o=!1,stopAtRawNbsp:a=!1}){if(typeof e!="string"||!e.length||((!r||typeof r!="number")&&(r=0),!e[r+1]))return null;if(e[r+1]&&(e[r+1].trim()||o&&`
\r`.includes(e[r+1])||a&&e[r+1]===g))return r+1;if(e[r+2]&&(e[r+2].trim()||o&&`
\r`.includes(e[r+2])||a&&e[r+2]===g))return r+2;for(let n=r+1,l=e.length;n<l;n++)if(e[n].trim()||o&&`
\r`.includes(e[n])||a&&e[n]===g)return n;return null}function c(e,r=0){return V({str:e,idx:r,stopAtNewlines:!1,stopAtRawNbsp:!1})}function I({str:e,idx:r,stopAtNewlines:o,stopAtRawNbsp:a}){if(typeof e!="string"||!e.length||((!r||typeof r!="number")&&(r=0),r<1))return null;if(e[~-r]&&(e[~-r].trim()||o&&`
\r`.includes(e[~-r])||a&&e[~-r]===g))return~-r;if(e[r-2]&&(e[r-2].trim()||o&&`
\r`.includes(e[r-2])||a&&e[r-2]===g))return r-2;for(let n=r;n--;)if(e[n]&&(e[n].trim()||o&&`
\r`.includes(e[n])||a&&e[n]===g))return n;return null}function y(e,r=0){return I({str:e,idx:r,stopAtNewlines:!1,stopAtRawNbsp:!1})}var x="8.0.16";var W=x;function F(e){var i;if(typeof e!="string")throw new TypeError(`string-extract-class-names: [THROW_ID_01] first str should be string, not ${typeof e}, currently equal to ${JSON.stringify(e,null,4)}`);let r=".# ~\\!@$%^&*()+=,/';:\"?><[]{}|`",o;function a(t){return typeof t=="string"&&!!t.length&&(t.charCodeAt(0)>64&&t.charCodeAt(0)<91||t.charCodeAt(0)>96&&t.charCodeAt(0)<123)}let n=null,l={res:[],ranges:[]};for(let t=0,u=e.length;t<=u;t++){n!==null&&t>=n&&(!((i=e[t])!=null&&i.trim())||r.includes(e[t]))&&(t>n+1&&(l.ranges.push([n,t]),l.res.push(`${o||""}${e.slice(n,t)}`),o&&(o=void 0)),n=null),e[t]&&n===null&&(e[t]==="."||e[t]==="#")&&(n=t);let s=c(e,t+4);e.startsWith("class",t)&&typeof y(e,t)=="number"&&e[y(e,t)]==="["&&typeof s=="number"&&e[s]==="="&&(c(e,s)&&a(e[c(e,s)])?n=c(e,s):`'"`.includes(e[c(e,s)])&&a(e[c(e,c(e,s))])&&(n=c(e,c(e,s))),o=".");let f=c(e,t+1);e.startsWith("id",t)&&e[y(e,t)]==="["&&f!==null&&e[f]==="="&&(a(e[c(e,f)])?n=c(e,f):`'"`.includes(e[c(e,f)])&&a(e[c(e,c(e,f))])&&(n=c(e,c(e,f))),o="#")}return l.ranges.length||(l.ranges=null),l}return M(_);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name string-left-right
 * @fileoverview Looks up the first non-whitespace character to the left/right of a given index
 * @version 6.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-left-right/}
 */
